#!/bin/sh
# $Id: veracrypt.SlackBuild,v 1.10 2018/10/06 17:54:33 root Exp root $
# Copyright 2015, 2016, 2017, 2018, 2019  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         veracrypt
# Descr:       free disk encryption software based on TrueCrypt
# URL:         https://veracrypt.fr/
# Build needs: 
# Needs:       
# Changelog:   
# 1.0f_2-1:    13/Jul/2015 by Eric Hameleers <alien@slackware.com>
#              * Initial build.
# 1.13-1:      10/aug/2015 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.15-1:      01/oct/2015 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.17-1:      16/may/2016 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.18-1:      18/aug/2016 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.19-1:      18/oct/2016 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.21-1:      11/jul/2017 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.23-1:      06/oct/2018 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.24_hotfix1-1:
#              07/dec/2019 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 
# Run 'sh veracrypt.SlackBuild' to build a Slackware package.
# The package (.t?z) and .txt file as well as build logs are created in /tmp .
# Install the package using 'installpkg' or 'upgradepkg --install-new'.
#
# -----------------------------------------------------------------------------

PRGNAM=veracrypt
SRCNAM=VeraCrypt
SRCVER="1.24-Hotfix1"
VERSION=$(echo $SRCVER |tr - _ |tr [A-Z] [a-z])
BUILD=${BUILD:-1}
NUMJOBS=${NUMJOBS:-"-j$(nproc)"}
TAG=${TAG:-alien}

WX=${WX:-3.0.4} # for the GUI

DOCS="License.txt Readme.txt ../doc/html ../doc/EFI-DCS/*.pdf"

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE[0]="$SRCDIR/${SRCNAM}_${SRCVER}_Source.tar.bz2"
SRCURL[0]="https://launchpad.net/${PRGNAM}/trunk/$(echo "${SRCVER}" |tr '[:upper:]' '[:lower:]')/+download/${SRCNAM}_${SRCVER}_Source.tar.bz2"

SOURCE[1]="$SRCDIR/wxWidgets-${WX}.tar.bz2"
SRCURL[1]="https://github.com/wxWidgets/wxWidgets/releases/download/v${WX}/wxWidgets-${WX}.tar.bz2"

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# You can use your own private machine.conf file to overrule machine defaults:
if [ -e $SRCDIR/machine.conf ]; then
  . $SRCDIR/machine.conf
elif [ -e /etc/slackbuild/machine.conf ]; then
  . /etc/slackbuild/machine.conf
else
  # Automatically determine the architecture we're building on:
  MARCH=$( uname -m )
  if [ -z "$ARCH" ]; then
    case "$MARCH" in
      i?86)    export ARCH=i586 ;;
      armv7hl) export ARCH=$MARCH ;;
      armv6hl) export ARCH=$MARCH ;;
      arm*)    export ARCH=arm ;;
      # Unless $ARCH is already set, use uname -m for all other archs:
      *)       export ARCH=$MARCH ;;
    esac
  fi
  # Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
  case "$ARCH" in
    i?86)      SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
               SLKLDFLAGS=""; LIBDIRSUFFIX=""
               ;;
    x86_64)    SLKCFLAGS="-O2 -fPIC"
               SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
               ;;
    armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
               SLKLDFLAGS=""; LIBDIRSUFFIX=""
               ;;
    armv6hl)   SLKCFLAGS="-O2 -march=armv6 -mfpu=vfp -mfloat-abi=hard"
               SLKLDFLAGS=""; LIBDIRSUFFIX=""
               ;;
    *)         SLKCFLAGS=${SLKCFLAGS:-"O2"}
               SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
               ;;
  esac
fi

case "$ARCH" in
    arm*)    TARGET=$ARCH-slackware-linux-gnueabi ;;
    *)       TARGET=$ARCH-slackware-linux ;;
esac

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
                          # remove old log files

# Source file availability:
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  if ! [ -f ${SOURCE[$i]} ]; then
    echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
    # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
    [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
    if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
    if ! [ "x${SRCURL[$i]}" == "x" ]; then
      echo "Will download file to $(dirname $SOURCE[$i])"
      lynx -dump "${SRCURL[$i]}" > "${SOURCE[$i]}" || true
      if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
        echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
        mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
        exit 1
      fi
    else
      echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
      exit 1
    fi
  fi
done

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  # Compensate for doubly compressed source version 1.19:
  tar -xf ${SOURCE[$i]} || gunzip -cd ${SOURCE[$i]} | tar -zxvf -
done

chown -R root:root .
chmod -R u+w,go+r-w,a+rX-st .

# Need that later:
WXDIR=$(pwd)/wxWidgets-$WX

# Compensate for sometimes absent root directory in source tarball:
cd src 2>/dev/null || cd ${SRCNAM}*/src

# Prepare patches:
touch $OUTPUT/patch-${PRGNAM}.log

# We do not need a self-extracting installer:
cat $SRCDIR/patches/veracrypt_no_makeself.patch | patch -p1 --verbose \
  2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log

# Fix gcc compilation error:
cat $SRCDIR/patches/veracrypt_fix_u64_gcc.patch | patch -p2 --verbose \
  2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log

echo Building ...
export LDFLAGS="$SLKLDFLAGS"
export CXXFLAGS="$SLKCFLAGS -maes"
export CFLAGS="$SLKCFLAGS -maes"

# First build a static wxGTK, then build veracrypt:
make WXSTATIC=1 WX_ROOT=${WXDIR} VERBOSE=1 wxbuild \
  2>&1 | tee $OUTPUT/make-${PRGNAM}_wx.log
make WXSTATIC=1 VERBOSE=1 \
  TC_EXTRA_LFLAGS+="-ldl ${LDFLAGS}" \
  TC_EXTRA_CXXFLAGS="${CXXFLAGS}" \
  TC_EXTRA_CFLAGS="${CFLAGS}" \
  2>&1 | tee $OUTPUT/make-${PRGNAM}.log

# Install the GUI/console combined binary:
mkdir -p $PKG/usr/bin
install -m0755 Main/${PRGNAM} $PKG/usr/bin/${PRGNAM}

# Also build a console-only version that does not depend on any GUI libs:
make clean
make NOGUI=1 WXSTATIC=1 WX_ROOT=${WXDIR} VERBOSE=1 wxbuild \
  2>&1 | tee $OUTPUT/make-${PRGNAM}-nox_wx.log
make NOGUI=1 WXSTATIC=1 VERBOSE=1 \
  TC_EXTRA_LFLAGS+="-ldl ${LDFLAGS}" \
  TC_EXTRA_CXXFLAGS="${CXXFLAGS}" \
  TC_EXTRA_CFLAGS="${CFLAGS}" \
  2>&1 | tee $OUTPUT/make-${PRGNAM}-nox.log

# Install the console-only binary:
mkdir -p $PKG/usr/bin
install -m0755 Main/${PRGNAM} $PKG/usr/bin/${PRGNAM}-nox

# Add a desktop entry:
mkdir -p $PKG/usr/share/pixmaps
install -m0644 $SRCDIR/${PRGNAM}.png $PKG/usr/share/pixmaps/${PRGNAM}.png

mkdir -p $PKG/usr/share/applications
cat << EOT > $PKG/usr/share/applications/${PRGNAM}.desktop
[Desktop Entry]
Type=Application
TryExec=${PRGNAM}
Exec=${PRGNAM}
Icon=${PRGNAM}
Comment=Disk encryption software
Terminal=false
Name=VeraCrypt
StartupNotify=true
Categories=System;
EOT

# Add this to the doinst.sh:
mkdir -p $PKG/install
cat <<EOINS >> $PKG/install/doinst.sh
# Update the desktop database:
if [ -x usr/bin/update-desktop-database ]; then
  chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
fi

# Update hicolor theme cache:
if [ -d usr/share/icons/hicolor ]; then
  if [ -x /usr/bin/gtk-update-icon-cache ]; then
    chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
  fi
fi

# Update the mime database:
if [ -x usr/bin/update-mime-database ]; then
  chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
fi

EOINS

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Compress the man page(s):
if [ -d $PKG/usr/man ]; then
  find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
  for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
fi

# Strip binaries (if any):
find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
  | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt

# Restore the original umask:
umask ${_UMASK_}

